#include <gb_graph.h>
#include <gb_flip.h>

#include "graph.h"
#include "pick.h"

/************************************************/
/* clear the picked_m field of each vertex of   */
/* the Graph pointed to by g                    */
/************************************************/

void clear_picked_m_field(Graph *g) {
  Vertex *v;

  for (v = g->vertices; v < g->vertices + g->n; v++) {
    v->picked_m = 0;
  }
}

/************************************************/
/************************************************/

Vertex *pick_0(Graph *g) {
  Vertex *v;

  while (1) {
    v = g->vertices + gb_unif_rand(g->n);
    if (v->picked_t == 1) {
      return v;
    }
  }
}

/************************************************/
/* pick 1 vertex from the tapestry network      */
/************************************************/

Vertex *pick_1(Graph *g) {
  Vertex *v;

  while (1) {
    v = g->vertices + gb_unif_rand(g->n);
    if (v->picked_t == 1 && v->picked_m == 0) {
      v->picked_m = 1;
      return v;
    }
  }
}

/************************************************/
/* pick n vertices from the tapestry network    */
/************************************************/

void pick_n(Graph *g, Vertex **vertex_array, int n) {
  Vertex *v;
  int i;

  for (i = 0; i < n; ) {
    v = g->vertices + gb_unif_rand(g->n);
    if (v->picked_t == 1 && v->picked_m == 0) {
      v->picked_m = 1;
      vertex_array[i++] = v;
    }
  }
}
