#include <gb_graph.h>

#include "stack.h"

/************************************************/
/************************************************/

stack_elem *create_elem(Vertex *current_v, int next_nbr, int level,
							int distance) {
  stack_elem *ptr = (stack_elem *) malloc(sizeof(stack_elem));

  ptr->current_v = current_v;
  ptr->next_nbr = next_nbr;
  ptr->level = level;
  ptr->distance = distance;
  ptr->next = NULL;

  return ptr;
}

/************************************************/
/************************************************/

void stack_initialize(stack *stk) {
  stk->count = 0;
  stk->top = NULL;
}

/************************************************/
/************************************************/

void stack_push(stack *stk, stack_elem *elem) {
  elem->next = stk->top;
  stk->top = elem;
  stk->count++;
}

/************************************************/
/************************************************/

void stack_pop(stack *stk) {
  stack_elem *p;

  p = stk->top;
  stk->top = stk->top->next;
  stk->count--;
  free(p);
}

/************************************************/
/************************************************/

stack_elem *stack_top(stack *stk) {
  return (stk->top);
}

/************************************************/
/************************************************/

int stack_empty(stack *stk) {
  if (stk->count == 0)
    return 1;
  else
    return 0;
}


/************************************************/
/************************************************/

void stack_free(stack *stk) {
  stack_elem *p = stk->top;
  stack_elem *temp;

  while (p != NULL) {
    temp = p;
    p = p->next;
    free(temp);
  }
  free(stk);
}
