#ifndef STACK_H
#define STACK_H

typedef struct stack_elem {
  Vertex *current_v;
  int next_nbr;
  int level;
  int distance;
  struct stack_elem *next;
} stack_elem;

typedef struct stack {
  int count;
  stack_elem *top;
} stack;

stack_elem *create_elem(Vertex *current_v, int next_nbr, int level,
							int distance);
void stack_initialize(stack *stk);
void stack_push(stack *stk, stack_elem *elem);
void stack_pop(stack *stk);
stack_elem *stack_top(stack *stk);
int stack_empty(stack *stk);
void stack_free(stack *stk);

#endif
