#include <gb_graph.h>

#include "graph.h"

/************************************************/
/* print all arcs of Graph pointed to by g      */
/************************************************/

void print_all_arcs(Graph *g) {
  Vertex *v;
  Arc *a;
  int i, count = 0;
    
  for (v = g->vertices, i = 0; v < g->vertices + g->n; v++, i++) {
    //    printf("%d(%s*%s):", i, v->name, v->nodeid);
    for (a = v->arcs; a; a = a->next) {         
      //      printf(" %s*%s", a->tip->name, a->tip->nodeid);
      count++;
    }
    //    printf("\n");
  }
  //  printf("\n");
  printf("print_all_arcs:  # of vertices = %ld, # of edges = %d\n",
                                                        g->n, count/2);
}

/************************************************/ 
/* reset arc lengths to 1                       */
/* (consider hop counts only)                   */ 
/************************************************/ 

int reset_arc_len(Graph *g) {
  Vertex *v;
  Arc *a;
  int count = 0;
                
  for (v = g->vertices; v < g->vertices + g->n; v++) {
    for (a = v->arcs; a; a = a->next) {
      a->len = 1;
      count++;
    }
  }
  return (count/2);
}
