#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "util.h"

/************************************************/
/* swaps two elements				*/
/************************************************/

void swap(int *a, int *b) {
  int tmp = *a;  
  *a = *b;
  *b = tmp;
}

/************************************************/
/* sorts an array using bubblesort		*/
/************************************************/

void bubblesort (int *array, int size) {
  int i, j;
  
  for (i = 0; i < size; i++)
    for (j = size - 1; j > i; j--)
      if (array[j] < array[j-1])
        swap(&array[j], &array[j-1]);
}   

/************************************************/
/* convert a hexadecimal/octal/quad/binary      */
/* character to its decimal value               */
/************************************************/

int hoqb_atoi(char hoqb_char) {
  if (hoqb_char >= '0' && hoqb_char <= '9')
    return (hoqb_char - '0');
  else if (hoqb_char >= 'a' && hoqb_char <= 'f')
    return (hoqb_char - 'a' + 10);
  else
    return -1;
}   
    
/************************************************/
/* convert a decimal value to its quad string   */
/************************************************/
    
void quad_itoa(int id, char *quad_str, int TAPESTRY_NODEID_SIZE) {
  int i;
  char hex_str[TAPESTRY_NODEID_SIZE/2 + 1];
                                                        
  sprintf(hex_str, "%0x", id);

  // convert each hexadecimal digit to two quad digits
  for (i = 0; i < strlen(hex_str); i++) {       
    switch (hex_str[i]) {
    case '0':
      quad_str[i*2] = '0'; quad_str[i*2+1] = '0';
      break;
    case '1':
      quad_str[i*2] = '0'; quad_str[i*2+1] = '1';
      break;
    case '2':
      quad_str[i*2] = '0'; quad_str[i*2+1] = '2';
      break; 
    case '3':
      quad_str[i*2] = '0'; quad_str[i*2+1] = '3';
      break;
    case '4':
      quad_str[i*2] = '1'; quad_str[i*2+1] = '0';
      break;
    case '5':
      quad_str[i*2] = '1'; quad_str[i*2+1] = '1';
      break;
    case '6':
      quad_str[i*2] = '1'; quad_str[i*2+1] = '2';
      break;
    case '7':
      quad_str[i*2] = '1'; quad_str[i*2+1] = '3';
      break;
    case '8':
      quad_str[i*2] = '2'; quad_str[i*2+1] = '0';
      break;
    case '9':
      quad_str[i*2] = '2'; quad_str[i*2+1] = '1';
      break;
    case 'a':
      quad_str[i*2] = '2'; quad_str[i*2+1] = '2';
      break;
    case 'b':
      quad_str[i*2] = '2'; quad_str[i*2+1] = '3';
      break;
    case 'c':
      quad_str[i*2] = '3'; quad_str[i*2+1] = '0';
      break;
    case 'd':
      quad_str[i*2] = '3'; quad_str[i*2+1] = '1';
      break;
    case 'e':
      quad_str[i*2] = '3'; quad_str[i*2+1] = '2';
      break;
    case 'f':
      quad_str[i*2] = '3'; quad_str[i*2+1] = '3';
      break;
    default:
      break;
    }
  }
  quad_str[i*2] = '\0';
}

/************************************************/
/* convert a decimal value to its binary string */
/************************************************/

void binary_itoa(int id, char *binary_str, int TAPESTRY_NODEID_SIZE) {
  int i;
  char hex_str[TAPESTRY_NODEID_SIZE/4 + 1];

  sprintf(hex_str, "%0x", id);

  // convert each hexadecimal digit to four binary digits
  for (i = 0; i < strlen(hex_str); i++) {
    switch (hex_str[i]) {
    case '0':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '0';
      break;
    case '1':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '1';
      break;
    case '2':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '0';
      break;
    case '3':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '1';
      break;
    case '4':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '0';
      break;
    case '5':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '1';
      break;
    case '6':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '0';
      break;
    case '7':
      binary_str[i*4] = '0'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '1';
      break;
    case '8':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '0';
      break;
    case '9':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '1';
      break;
    case 'a':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '0';
      break;
    case 'b':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '0';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '1';
      break;
    case 'c':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '0';
      break;
    case 'd':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '0'; binary_str[i*4+3] = '1';
      break;
    case 'e':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '0';
      break;
    case 'f':
      binary_str[i*4] = '1'; binary_str[i*4+1] = '1';
      binary_str[i*4+2] = '1'; binary_str[i*4+3] = '1';
      break;
    default:
      break;
    }
  }
  binary_str[i*4] = '\0';
}
